using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Routing;
using Microsoft.AspNetCore.Authorization;

using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Logging;

using AyaNova.Models;
using AyaNova.Api.ControllerHelpers;
using AyaNova.Biz;


namespace AyaNova.Api.Controllers
{
    //DOCUMENTATING THE API
    //https://docs.microsoft.com/en-us/dotnet/csharp/programming-guide/xmldoc/recommended-tags-for-documentation-comments
    //https://github.com/domaindrivendev/Swashbuckle.AspNetCore#include-descriptions-from-xml-comments

    /// <summary>
    /// Translation controller
    /// </summary>
    [ApiController]
    [ApiVersion("8.0")]
    [Route("api/v{version:apiVersion}/translation")]
    [Produces("application/json")]
    [Authorize]
    public class TranslationController : ControllerBase
    {
        private readonly AyContext ct;
        private readonly ILogger<TranslationController> log;
        private readonly ApiServerState serverState;


        /// <summary>
        /// ctor
        /// </summary>
        /// <param name="dbcontext"></param>
        /// <param name="logger"></param>
        /// <param name="apiServerState"></param>  
        public TranslationController(AyContext dbcontext, ILogger<TranslationController> logger, ApiServerState apiServerState)
        {
            ct = dbcontext;
            log = logger;
            serverState = apiServerState;
        }




        /// <summary>
        /// Get Translation all values
        /// </summary>
        /// <param name="id"></param>
        /// <returns>A single Translation and it's values</returns>
        [HttpGet("{id}")]
        public async Task<IActionResult> GetTranslation([FromRoute] long id)
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));


            if (!ModelState.IsValid)
            {
                return BadRequest(new ApiErrorResponse(ModelState));
            }

            //Instantiate the business object handler        
            TranslationBiz biz = TranslationBiz.GetBiz(ct, HttpContext);

            var o = await biz.GetAsync(id);

            if (o == null)
            {
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));
            }

            return Ok(ApiOkResponse.Response(o));
        }



        /// <summary>
        /// Get Translations list
        /// </summary>
        /// <returns>List in alphabetical order of all Translations</returns>    
        [HttpGet("list")]
        public async Task<IActionResult> TranslationList()
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));

            //Instantiate the business object handler
            TranslationBiz biz = TranslationBiz.GetBiz(ct, HttpContext);

            var l = await biz.GetTranslationListAsync();
            return Ok(ApiOkResponse.Response(l));
        }


#if (DEBUG)
        /// <summary>
        /// Get a coverage report of translation keys used versus unused
        /// </summary>
        /// <returns>Report of all unique translation keys requested since last  server reboot</returns>    
        [HttpGet("translationkeycoverage")]
        public async Task<IActionResult> TranslationKeyCoverage()
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));

            //Instantiate the business object handler
            TranslationBiz biz = TranslationBiz.GetBiz(ct, HttpContext);

            var l = await biz.TranslationKeyCoverageAsync();
            return Ok(ApiOkResponse.Response(l));
        }
#endif


        /// <summary>
        /// Get subset of translation values
        /// </summary>
        /// <param name="inObj">List of translation key strings</param>
        /// <returns>A key value array of translation text values</returns>    
        [HttpPost("subset")]
        public async Task<IActionResult> SubSet([FromBody] List<string> inObj)
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));

            //Instantiate the business object handler

            //Instantiate the business object handler
            TranslationBiz biz = TranslationBiz.GetBiz(ct, HttpContext);

            var l = await biz.GetSubsetAsync(inObj);
            return Ok(ApiOkResponse.Response(l));
        }


        /// <summary>
        /// Duplicates an existing translation with a new name 
        /// </summary>
        /// <param name="inObj">NameIdItem object containing source translation Id and new name</param>
        /// <param name="apiVersion">From route path</param>
        /// <returns>Error response or newly created translation</returns>    
        [HttpPost("duplicate")]
        public async Task<IActionResult> Duplicate([FromBody] NameIdItem inObj, ApiVersion apiVersion)
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));

            //Instantiate the business object handler
            TranslationBiz biz = TranslationBiz.GetBiz(ct, HttpContext);

            var o = await biz.DuplicateAsync(inObj);

            if (o == null)
            {
                //error return
                return BadRequest(new ApiErrorResponse(biz.Errors));
            }
            else
            {
                return CreatedAtAction(nameof(TranslationController.GetTranslation), new { id = o.Id, version = apiVersion.ToString() }, new ApiCreatedResponse(o));
            }
        }



        /// <summary>
        /// Put (UpdateTranslationItemDisplayText) 
        /// Update a single key with new display text
        /// </summary>     
        /// <param name="inObj">NewText/Id/Concurrency token object. NewText is new display text, Id is TranslationItem Id, concurrency token is required</param>
        /// <returns></returns>
        [HttpPut("updatetranslationitemdisplaytext")]
        public async Task<IActionResult> PutTranslationItemDisplayText([FromBody] NewTextIdConcurrencyTokenItem inObj)
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));

            if (!ModelState.IsValid)
            {
                return BadRequest(new ApiErrorResponse(ModelState));
            }

            var oFromDb = await ct.TranslationItem.SingleOrDefaultAsync(z => z.Id == inObj.Id);

            if (oFromDb == null)
            {
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));
            }

            //Now fetch translation for rights and to ensure not stock
            var oDbParent = await ct.Translation.SingleOrDefaultAsync(z => z.Id == oFromDb.TranslationId);
            if (oDbParent == null)
            {
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));
            }

            if (!Authorized.HasModifyRole(HttpContext.Items, AyaType.Translation))
            {
                return StatusCode(403, new ApiNotAuthorizedResponse());
            }

            //Instantiate the business object handler 
            TranslationBiz biz = TranslationBiz.GetBiz(ct, HttpContext);

            try
            {
                if (!await biz.PutTranslationItemDisplayTextAsync(oFromDb, inObj, oDbParent))
                {
                    return BadRequest(new ApiErrorResponse(biz.Errors));
                }
            }
            catch (DbUpdateConcurrencyException)
            {
                if (!await biz.TranslationItemExistsAsync(inObj.Id))
                {
                    return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));
                }
                else
                {
                    //exists but was changed by another user
                    //I considered returning new and old record, but where would it end?
                    //Better to let the client decide what to do than to send extra data that is not required
                    return StatusCode(409, new ApiErrorResponse(ApiErrorCode.CONCURRENCY_CONFLICT));
                }
            }


            return Ok(ApiOkResponse.Response(new { Concurrency = oFromDb.Concurrency }));
        }



        /// <summary>
        /// Put (UpdateTranslationItemDisplayText) 
        /// Update a list of items with new display text
        /// </summary>     
        /// <param name="inObj">Array of NewText/Id/Concurrency token objects. NewText is new display text, Id is TranslationItem Id, concurrency token is required</param>
        /// <returns></returns>
        [HttpPut("updatetranslationitemsdisplaytext")]
        public async Task<IActionResult> PutTranslationItemsDisplayText([FromBody] List<NewTextIdConcurrencyTokenItem> inObj)
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));

            if (!ModelState.IsValid)
            {
                return BadRequest(new ApiErrorResponse(ModelState));
            }

            var oFromDb = await ct.TranslationItem.AsNoTracking().SingleOrDefaultAsync(z => z.Id == inObj[0].Id);

            if (oFromDb == null)
            {
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));
            }

            //Now fetch translation for rights and to ensure not stock
            var oDbParent = await ct.Translation.SingleOrDefaultAsync(z => z.Id == oFromDb.TranslationId);
            if (oDbParent == null)
            {
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));
            }

            if (!Authorized.HasModifyRole(HttpContext.Items, AyaType.Translation))
            {
                return StatusCode(403, new ApiNotAuthorizedResponse());
            }

            //Instantiate the business object handler 
            TranslationBiz biz = TranslationBiz.GetBiz(ct, HttpContext);

            try
            {
                if (!await biz.PutTranslationItemsDisplayTextAsync(inObj, oDbParent))
                {
                    return BadRequest(new ApiErrorResponse(biz.Errors));
                }
            }
            catch (DbUpdateConcurrencyException)
            {

                //exists but was changed by another user
                //I considered returning new and old record, but where would it end?
                //Better to let the client decide what to do than to send extra data that is not required
                return StatusCode(409, new ApiErrorResponse(ApiErrorCode.CONCURRENCY_CONFLICT));
            }
            return NoContent();
        }



        /// <summary>
        /// Put (UpdateTranslationName)
        /// Update a translation to change the name (non-stock Translations only)
        /// </summary>     
        /// <param name="inObj">NewText/Id/Concurrency token object. NewText is new translation name, Id is Translation Id, concurrency token is required</param>
        /// <returns></returns>
        [HttpPut("updatetranslationname")]
        public async Task<IActionResult> PutTranslationName([FromBody] NewTextIdConcurrencyTokenItem inObj)
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));

            if (!ModelState.IsValid)
            {
                return BadRequest(new ApiErrorResponse(ModelState));
            }

            var oFromDb = await ct.Translation.SingleOrDefaultAsync(z => z.Id == inObj.Id);

            if (oFromDb == null)
            {
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));
            }


            if (!Authorized.HasModifyRole(HttpContext.Items, AyaType.Translation))
            {
                return StatusCode(403, new ApiNotAuthorizedResponse());
            }

            //Instantiate the business object handler 
            TranslationBiz biz = TranslationBiz.GetBiz(ct, HttpContext);

            try
            {
                if (!await biz.PutTranslationNameAsync(oFromDb, inObj))
                {
                    return BadRequest(new ApiErrorResponse(biz.Errors));
                }

            }
            catch (DbUpdateConcurrencyException)
            {
                if (!await biz.TranslationExistsAsync(inObj.Id))
                {
                    return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));
                }
                else
                {
                    //exists but was changed by another user
                    //I considered returning new and old record, but where would it end?
                    //Better to let the client decide what to do than to send extra data that is not required
                    return StatusCode(409, new ApiErrorResponse(ApiErrorCode.CONCURRENCY_CONFLICT));
                }
            }

            return Ok(ApiOkResponse.Response(new { Concurrency = oFromDb.Concurrency }));
        }


        /// <summary>
        /// Delete Translation
        /// </summary>
        /// <param name="id"></param>
        /// <returns>Ok</returns>
        [HttpDelete("{id}")]
        public async Task<IActionResult> DeleteTranslation([FromRoute] long id)
        {
            if (serverState.IsClosed)
                return StatusCode(503, new ApiErrorResponse(serverState.ApiErrorCode, null, serverState.Reason));

            if (!ModelState.IsValid)
            {
                return BadRequest(new ApiErrorResponse(ModelState));
            }


            //Fetch translation and it's children
            //(fetch here so can return proper REST responses on failing basic validity)
            var dbObj = await ct.Translation.Include(z => z.TranslationItems).SingleOrDefaultAsync(z => z.Id == id);
            if (dbObj == null)
            {
                return NotFound(new ApiErrorResponse(ApiErrorCode.NOT_FOUND));
            }

            if (!Authorized.HasDeleteRole(HttpContext.Items, AyaType.Translation))
            {
                return StatusCode(403, new ApiNotAuthorizedResponse());
            }


            //Instantiate the business object handler
            TranslationBiz biz = TranslationBiz.GetBiz(ct, HttpContext);
            if (!await biz.DeleteAsync(dbObj))
            {
                return BadRequest(new ApiErrorResponse(biz.Errors));
            }

            return NoContent();
        }


#if (DEBUG)
        public class TranslationCoverageInfo
        {
            public List<string> RequestedKeys { get; set; }
            public int RequestedKeyCount { get; set; }
            public List<string> NotRequestedKeys { get; set; }
            public int NotRequestedKeyCount { get; set; }

            public TranslationCoverageInfo()
            {
                RequestedKeys = new List<string>();
                NotRequestedKeys = new List<string>();
            }

        }
#endif

    }
}